import { Data } from "apache-arrow";
import { Point, LineString, Polygon, MultiPoint, MultiLineString, MultiPolygon } from "./type";
export type PointData = Data<Point>;
export type LineStringData = Data<LineString>;
export type PolygonData = Data<Polygon>;
export type MultiPointData = Data<MultiPoint>;
export type MultiLineStringData = Data<MultiLineString>;
export type MultiPolygonData = Data<MultiPolygon>;
export type GeoArrowData = PointData | LineStringData | PolygonData | MultiPointData | MultiLineStringData | MultiPolygonData;
export declare function isPointData(data: Data): data is PointData;
export declare function isLineStringData(data: Data): data is LineStringData;
export declare function isPolygonData(data: Data): data is PolygonData;
export declare function isMultiPointData(data: Data): data is MultiPointData;
export declare function isMultiLineStringData(data: Data): data is MultiLineStringData;
export declare function isMultiPolygonData(data: Data): data is MultiPolygonData;
